package com.V10lator.TimeEvent;

import java.util.Collection;
import org.bukkit.block.Block;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Sign;

public class EventThread extends Thread
{
  private TimeEvent plugin;
  public EventThread(final TimeEvent plugin)
  {
    this.plugin = plugin;
  }
  
  public void run()
  {
	Collection<EventStone> eventStones = this.plugin.getValues();
	Block block = null;
	World world = null;
	String now = new String();
	String time = new String();
	short active = 0;
	int x = 0;
	int y = 0;
	int z = 0;
	Sign schuidl = null;
	Material material = null;
	for(EventStone sign: eventStones)
	{
	  active = sign.getActive();
	  x = sign.getX();
	  y = sign.getY();
	  z = sign.getZ();
	  world = this.plugin.getServer().getWorld(sign.getWorld());
	  block = world.getBlockAt(x, y, z);
	  material = block.getType();
	  now = this.plugin.l24t.getTime(world);
	  if(active <= 0)
	  {
		time = sign.getTime();
	    if(time.equals(now))
	    {
		  block.setType(Material.REDSTONE_TORCH_ON);
		  sign.setActive((short)5);
	    }
	    else
	    {
	      //Update sign
		  if(material == Material.SIGN_POST)
		  {
		    schuidl = ((Sign)block.getState());

	        time = this.plugin.l24t.countdown(world, sign.getTime());
	        
	        schuidl.setLine(0, "[" + ChatColor.YELLOW + "Time" + ChatColor.GREEN + "Event" + ChatColor.BLACK + "]");
	        schuidl.setLine(1, "");
	        schuidl.setLine(2, ChatColor.BLUE + "Time left:");
	        schuidl.setLine(3, ChatColor.BLUE + time.split(":")[0] + "h " + time.split(":")[1] + "m");
		    schuidl.update();
		  }
		  else
		  {
		    this.plugin.info2log("No sign at " + x + "," + y + "," + z);
		    this.plugin.removeEventStone(block);
		    this.plugin.info2log("Removed from list");
		  }
	    }
	  }
	  else if(active == 1)
	  {
		sign.setActive((short)0);
		block.setTypeIdAndData(Material.SIGN_POST.getId(), sign.getOrig(), true);
	  }
	  else
		sign.setActive((short)(active - 1));
	}
  }
}

